/*
MISSION SPEECHES - CREDITS:
Scout, British 1 - Krax
British 2 - Chris
British Soldier - Mozo
Officer  - Reptile
Bomber 1 - Buza
Bomber 2 - Arthur Brown
*/

// TUNING PARAMETERS:
// Here comes the parameters, which need fine tuning.
//temp vars
/*
new iMS10_SP001[]="Scout: STOP! Krauts ahead!";
new iMS10_SP002[]="Officer: Good job soldiers! We must place fortifications in this narrow and do it quickly. Whenever it falls back to the enemy we would be in serious trouble!";
new iMS10_SP003[]="Officer: How could you let this happen?! Now our chances of securing this area are blew with the wind!";
new iMS10_SP004A[]="Scout: That was easy!";
new iMS10_SP004B[]="British Soldier: Hell yeah! Let's get them lads!";
new iMS10_SP005A[]="Officer: Scouts reported a German offensive heading our way. Without reinforcements we're not gonna outlast them!";
new iMS10_SP005B[]="British Soldier: We can't contact the HQ from here ... we must use the Radio Tower located at the hilltop, Sir! There must be a way to reach it and transmit a signal to HQ!";
new iMS10_SP005C[]="Officer: Make it quick men! We've only have just a few minutes left!";
new iMS10_SP006[]="Officer: Get ready gentlemen, they're upon us, we're about being doomed!";
new iMS10_SP007A[]="Officer: Great job! Now it's time to call in for reinforcements!";
new iMS10_SP007B[]="Officer: Sergeant Major Stampleton here! We need reinforcements at position ... as soon as possible!";
new iMS10_SP008A[]="Officer: We're pinned down! We need aerial support to silence those artilleries!";
new iMS10_SP008B[]="Bomber 1: You're too deep behind enemy lines, Sir! In order to prevent friendly fire we need some guidance from you!";
new iMS10_SP008C[]="Bomber 1: Try to find anything that burns to mark the area for us!";
new iMS10_SP009A[]="Bomber 1: Thanks for the fire, guys ... Flying Fortress is on its way ...";
new iMS10_SP009B[]="Bomber 2: I am the God of Hellfire ... and I bring you";
new iMS10_SP010A[]="British 1: Look! Someone's there!"
new iMS10_SP010B[]="El Ifrit: These may be my last words, good soldiers. Me, who is valiant and pure of spirit, have found out that the Germans are regrouping at Mort---aaaaaagggh"
new iMS10_SP010C[]="British 1: He's dead ... But where is this Fort Aaaaagh? I have the foggiest, as there's no fort around ..."
new iMS10_SP010D[]="British 2: Do you suppose he meant the Camaaaaaargue?"
new iMS10_SP010E[]="British 1: No, that's bloody far from here. Did he mean Mortaaaaaain then? That's probable, we must scout that area."
*/
// TODO: ===============================================================================================
// Write here tasks to be done.


// DECLARATIONS: =======================================================================================
#include "script.inc"
#include antiair.inc
// Write here global variable declarations and definitions. All globals should start with letter: 'g'!

new bool:gOffensiveStarted=true;
new bool:gSmokeStarted=false;
new bool:gSzaladhatnak=true;
new bool:gIfritFound=true;
new bool:gInitReinfStarted=true;

new Float:gGermanRaidMin=260.0;
new Float:gGermanRaidMax=540.0;

//new gTempWav[100]="Sounds\\Game\\Speech\\Mission\\TEMPORARY.mp3";
new bool:MS9HidDone=true

//======================================================================================================
public main() // A palya belepesi pontja, helyette a PostGameStart fuggvenyt hasznald
	CommonAKMain();


//======================================================================================================
public PostGameStart()
{
// Some must have stuff:
	CommonAKInit();
	
	if(IsScenario())
	{
		ScenarioPrepare();
	}
	
// Add objectives:
	AddObjective( "GetRadar", OT_PRIMARY, "#iMS10_PS01#", "#iMS10_PL01#", OS_IN_PROGRESS );
	AddObjective( "HoldNarrow", OT_PRIMARY, "#iMS10_PS02#", "#iMS10_PL02#", OS_SLEEPING );

	AddObjective( "GetRadio", OT_SECONDARY, "#iMS10_SS01#", "#iMS10_SL01#", OS_SLEEPING );
	AddObjective( "MarkArea", OT_SECONDARY, "#iMS10_SS02#", "#iMS10_SL02#", OS_SLEEPING );		

	AddObjective( "FindIfrit", OT_HIDDEN, "#iMS10_HS01#", "#iMS10_HL01#", OS_IN_PROGRESS );

	// Add objective related events:
	AddUserEvent( "TeamElimSucceed", UE_TEAMELIM_SUCC );
	// AddUserEvent( "GroupSurviveFailed", UE_GROUP_SURV_FAIL );
	AddUserEvent( "ObjectiveChanged", UE_OBJECTIVE_CHANGED );
	HackAntiAirInit();

	AddAKEntityEvent( "SomeEntered", ANY_ENTITY, UNIT_AREA_ENTER );
	AddAKEntityEvent( "SomeHQCaptured", ANY_ENTITY, HQ_TAKEOVER );
	AddAKEntityEvent( "ArtilleryAttacks", GetEntity( "arti1" ), UNIT_BEGIN_COMBAT );		
	AddAKEntityEvent( "ArtilleryAttacks", GetEntity( "arti2" ), UNIT_BEGIN_COMBAT );		
	AddAKEntityEvent( "ArtilleryAttacks", GetEntity( "arti3" ), UNIT_BEGIN_COMBAT );		
	AddAKEntityEvent( "ArtilleryAttacks", GetEntity( "arti4" ), UNIT_BEGIN_COMBAT );		
	AddAKEntityEvent( "ArtilleryAttacks", GetEntity( "arti5" ), UNIT_BEGIN_COMBAT );		
	AddAKEntityEvent( "SomeTeamChanged", ANY_ENTITY, UNIT_TEAM_CHANGED );

	AddAKEntityEvent( "RadarDied", GetEntity( "radar_site1" ), UNIT_DIED );

	AddTimerEvent( "AutoSendGRs", 420.0, "GameLogic", true );
	// Additional Mission Objective:
// Start doing some things:
	StartTheMap();
	MS9HidDone=(GetGlobalVariable("gvMS09_SecretDocuments")==1);
//	AddTimerEvent( "MenyetEgyBuzi", 0.25, "GameLogic", true);
	MakeUnSelectable(GetEntity( "ifrit" ));
}

public MenyetEgyBuzi()
{
	if(gSmokeStarted)
	{
		SetShortInfo("gSmokeStarted=true");
	}
	else
	{
		SetShortInfo("gSmokeStarted=false");	
	}
}

public ScenarioPrepare()
{
	new Iterator:iti=Iterate("StartingPlayerUnits");
	while(ItNext(iti))
	{
		AddToGroup( "starters", ItEntity(iti) );
	}
	ItStop(iti);
}

public RadarDied()
{
	RemoveEvent( "RadarDied" );
	SetObjectiveState( "GetRadar", OS_FAILED );
	AddTimerEvent( "GameOverMan", 3.0, "GameLogic", true);
}

public SomeTeamChanged(DrID:UndWho)
{
	if(GetPropertyInt( UndWho, "Team" )==0)
	{
		SetPropertyString( UndWho, "Group", "");	
	}
}

public AutoSendGRs()
{
	RemoveEvent( "AutoSendGRs" );
	if(gInitReinfStarted)
		AddTimerEvent( "SendGermanRaider", Float:(FloatRnd( gGermanRaidMin, gGermanRaidMax )), "GameLogic", true);
	gInitReinfStarted=false;
}

//Various Events...
public SomeHQCaptured(DrID:UndHQ)
{
	if(UndHQ==GetEntity( "hq_checkpoint" ))
	{
		if(GetObjectiveState( "HoldNarrow" )==OS_SLEEPING
		&&GetPropertyInt( UndHQ, "Team" )==gPlayerTeam)
		{
			AddSoundMessage("#iMS10_SP002#", "Sounds\\Game\\Speech\\Mission\\MS10_SP002.mp3");
			SetObjectiveState( "HoldNarrow", OS_IN_PROGRESS );
			if(gInitReinfStarted)
				AddTimerEvent( "SendGermanRaider", Float:(FloatRnd( gGermanRaidMin, gGermanRaidMax )), "GameLogic", true);
			gInitReinfStarted=false;
		}
		if(GetObjectiveState( "HoldNarrow" )==OS_IN_PROGRESS
		 &&GetPropertyInt( UndHQ, "Team" )!=gPlayerTeam)
		{
			AddSoundMessage("#iMS10_SP003#", "Sounds\\Game\\Speech\\Mission\\MS10_SP003.mp3");
			SetObjectiveState( "HoldNarrow", OS_FAILED );
			TeleportCameraToEnt( GetEntity( "hq_checkpoint" ));
			AddAKEntityEvent( "GameOverMan", ANY_ENTITY, MESSAGE_END );	
			SetCameraActualPitch( 90.0 );
			SetCameraActualDistance( 50.0 );
			SetCameraRotSpeed(1.0);
			SetCameraTargetRotate( GetCameraActualRotate()+100.0 );
			SetCameraZoomSpeed(1.0);
			SetCameraTargetDistance( 15.0 );
			SetCameraPitchSpeed(5.0);
			SetCameraTargetPitch( 45.0 );	
		}
	}
	
	if(UndHQ==GetEntity( "hq_radio" ))
	{
		if(GetPropertyInt( UndHQ, "Team" )==gPlayerTeam)
		{
			if(GetObjectiveState( "GetRadio" )==OS_IN_PROGRESS)
			{
				AddSoundMessage("#iMS10_SP007A#", "Sounds\\Game\\Speech\\Mission\\MS10_SP007A.mp3");
				AddSoundMessage("#iMS10_SP007B#", "Sounds\\Game\\Speech\\Mission\\MS10_SP007B.mp3");
				SetObjectiveState( "GetRadio", OS_COMPLETED );
				TimeToCallReinf();
			}
			if(gInitReinfStarted)
				AddTimerEvent( "SendGermanRaider", Float:(FloatRnd( gGermanRaidMin, gGermanRaidMax )), "GameLogic", true);
			gInitReinfStarted=false;
			AddTimerEvent( "SendRadioSoldiers", Float:(FloatRnd( gGermanRaidMin, gGermanRaidMax )*0.75), "GameLogic", true );
		}
	}
	
	if(UndHQ==GetEntity( "hq_radar" )
	 &&(GetObjectiveState( "GetRadar" )==OS_IN_PROGRESS
	 &&GetPropertyInt( UndHQ, "Team" )==gPlayerTeam))
	{
		SetObjectiveState( "GetRadar", OS_COMPLETED );
		AddTimerEvent( "GameDoneMan", 2.0, "GameLogic", true );
		SetCutScene(true);
	}
}

public SomeEntered(DrID:UndWho)
{
	new DrID:UndWhere=GetMsgParamObject();
	if(UndWhere==GetEntity( "offensive_trigger" )&&GetPropertyInt( UndWho, "Team" )==gPlayerTeam&&gOffensiveStarted)
	{
		SetCutScene(true);
		gOffensiveStarted=false;
		ShowTheRadio();
	}
	
	if(UndWhere==GetEntity( "smoke_trigger" ))
	{
		if(GetPropertyInt( UndWho, "Team" )==gPlayerTeam&&gSmokeStarted)
		{
			gSmokeStarted=false;
			ActivateEntity( GetEntity( "ifrit" ) );
			ShowEntity( GetEntity( "ifrit" ) );
			DamageEntity( GetEntity( "ifrit" ), 100.0, 49 );
			gIfritFound=false;
			ShowTheBombard();
		}
		//this is necessary to make sure noone walks into the fire
		if(!gSmokeStarted&&GetObjectiveState("MarkArea")!=OS_SLEEPING)
		{
			new Float:lTmpVec3_1[vec3];
			new Float:lTmpVec3_2[vec3];
			new Float:lTmpVec3_3[vec3];
			GetPropertyVec3( UndWhere, "LogicalPos_", lTmpVec3_1);
			GetPropertyVec3( UndWho, "LogicalPos_", lTmpVec3_2);		
			DiffVec3(lTmpVec3_1,lTmpVec3_2,lTmpVec3_3)
			AddVec3( lTmpVec3_2, lTmpVec3_3, lTmpVec3_1 );
			CmdMove( UndWho, Q_OVERRIDE, lTmpVec3_1, MF_DIRECT );
		}
	}
	
	if(UndWhere==GetEntity( "ifrit_trigger_s" )&&gIfritFound&&GetPropertyInt( UndWho, "Team" )==gPlayerTeam)
	{
		gIfritFound=false;
		if(CountLivingInSelector( "ifrit_trigger_b" )>1&&CountLivingInSelector( "ifrit_trigger_s" )==1)
		{
			ShowElIfrit();		
		}
		else
		{
			ActivateEntity( GetEntity( "ifrit" ) );
			ShowEntity( GetEntity( "ifrit" ) );
			DamageEntity( GetEntity( "ifrit" ), 100.0,49 );
			AddSoundMessage("#iMS10_SP010F#", "Sounds\\Game\\Speech\\Mission\\MS10_SP010F.mp3");			
		}	
	}
	
	if(UndWhere==GetEntity( "szaladjatok_trigger" )
	 &&(GetPropertyInt( UndWho, "Team" )==gPlayerTeam
	 &&gSzaladhatnak)
	 &&!IsInstanceOf( UndWho, GetClassID( "cAirplane" )))
	{
		gSzaladhatnak=false;
		CmdGroupMount( "befuto_panther1", Q_OVERRIDE, GetEntity( "befut_panther1" ));
		CmdGroupMount( "befuto_panther2", Q_OVERRIDE, GetEntity( "befut_panther2" ));
		CmdGroupMount( "befuto_tiger", Q_OVERRIDE, GetEntity( "befut_tiger" ));
		CmdGroupMount( "befuto_flame", Q_OVERRIDE, GetEntity( "befut_flame" ));
		CmdMoveToEnt( GetEntity( "befut_tiger" ), GetEntity( "beas_tiger" ), Q_OVERRIDE, MF_ATTACKMOVE );
		CmdMoveToEnt( GetEntity( "befut_panther1" ), GetEntity( "beas_panther1" ), Q_OVERRIDE, MF_ATTACKMOVE );
		CmdMoveToEnt( GetEntity( "befut_panther2" ), GetEntity( "beas_panther2" ), Q_OVERRIDE, MF_ATTACKMOVE );
		CmdMoveToEnt( GetEntity( "befut_flame" ), GetEntity( "beas_flame" ), Q_OVERRIDE, MF_ATTACKMOVE );
		CmdTurnToEnt( GetEntity( "befut_tiger" ), GetEntity( "beas_flame" ), Q_ENQUEUE );
		CmdTurnToEnt( GetEntity( "befut_panther1" ), GetEntity( "beas_flame" ), Q_ENQUEUE );
		CmdTurnToEnt( GetEntity( "befut_panther2" ), GetEntity( "beas_flame" ), Q_ENQUEUE );
		CmdDigin( GetEntity( "befut_tiger" ), Q_ENQUEUE);
		CmdDigin( GetEntity( "befut_panther1" ), Q_ENQUEUE);
		CmdDigin( GetEntity( "befut_panther2" ), Q_ENQUEUE);
		CmdDigin( GetEntity( "befut_flame" ),Q_ENQUEUE);
 		AddAKEntityEvent( "TimCsendzs", GetEntity( "befut_tiger" ), UNIT_TEAM_CHANGED );
 		AddAKEntityEvent( "TimCsendzs", GetEntity( "befut_panther1" ), UNIT_TEAM_CHANGED );
 		AddAKEntityEvent( "TimCsendzs", GetEntity( "befut_panther2" ), UNIT_TEAM_CHANGED );
 		AddAKEntityEvent( "TimCsendzs", GetEntity( "befut_flame" ), UNIT_TEAM_CHANGED );
	}
}

public TimCsendzs(DrID:Tank)
{
	RemoveEntityEvent("TimCsendzs",Tank);
	if(IsPlayer( Tank ))
		CmdStop( Tank, Q_OVERRIDE );
}

//INTRO--START
public StartTheMap()
{
	SetCameraActualPitch( 75.0 );
	SetCameraActualRotate( 175.0 );
	SetCameraActualDistance( 35.0 );

	SetCameraRotSpeed(1.0);
	SetCameraPitchSpeed(4.5);
	SetCameraZoomSpeed(5.0);
	SetCameraSpeed(2.5);
	
	SetCameraTargetPitch( 55.0 );
	SetCameraTargetRotate( 167.5 );
	SetCameraTargetDistance( 55.0 );

	TeleportCameraToEnt(GetEntity( "cam_intro1" ));
	MoveCameraToEnt( GetEntity( "cam_intro2" ));
	
	
	SetCutScene(true);
	new Iterator:iti=Iterate("starters");
	while(ItNext(iti))
	{
		MakeInvulnerable(ItEntity(iti));
		AddAKEntityEvent( "MegalljBitang", ItEntity(iti), UNIT_ENEMY_SEEN );
	}
	SetSpeedInSelector( "starters", 9.0 );
	FormationMoveToEnt("starters",GetEntity( "wp_startpos" ),Q_OVERRIDE, MF_DIRECT+MF_ATTACKMOVE);
	CmdMoveToEnt( GetEntity( "hullajelolt" ), GetEntity( "wp_startpos" ), Q_OVERRIDE, MF_ATTACKMOVE );	
	AddAKEntityEvent( "IntroOver", GetEntity( "hullajelolt" ), UNIT_DIED );
	AddAKEntityEvent( "IntroOver", GetEntity( "hullajelolt" ), UNIT_TEAM_CHANGED );
	AddTimerEvent( "Mittomen", 16.66, "GameLogic", true);
	AddTimerEvent( "MegalljBitang", 2.5, "GameLogic",true );
}

public Mittomen()
{
	RemoveEvent( "Mittomen" );
	new Iterator:iti=Iterate("starters");
	while(ItNext(iti))
	{
		MakeVulnerable(ItEntity(iti));
		CmdAttack( ItEntity(iti), Q_OVERRIDE, GetEntity( "hullajelolt" ) );
	}
}

public ArtilleryAttacks()
{
	static ArtiPT=0;
	static FowBacaName[100];
	static Float:CamPos[vec3];
	static Float:CamRot;
	static Float:CamZoom;
	static Float:CamPitch;
	switch(ArtiPT)
	{
	case 0:
		{
			RemoveEvent( "ArtilleryAttacks" );
			SetCutScene(true);
			SetGameSpeed( 0.25 );
			GetCameraActualPos( CamPos );
			CamRot=GetCameraActualRotate();
			CamZoom=GetCameraActualDistance();
			CamPitch=GetCameraActualPitch();
			AddSoundMessage("#iMS10_SP008A#", "Sounds\\Game\\Speech\\Mission\\MS10_SP008A.mp3");
			new Float:lTmpVec3[vec3];
			GetPropertyVec3( GetEntity( "arti3" ), "LogicalPos_", lTmpVec3 );
			new DrID:FowBaca=CreateEntity( "fowbacon_40", lTmpVec3 );
			SetPropertyInt( FowBaca, "Team", gPlayerTeam );
			GetPropertyString( FowBaca, "StringID", 100, FowBacaName );
			AddAKEntityEvent( "ArtilleryAttacks", ANY_ENTITY, MESSAGE_END );
		}	
	case 1:
		{
			SetGameSpeed( 0.05 );
			MoveCameraToEnt( GetEntity( "arti3" ) );
			AddSoundMessage("#iMS10_SP008B#", "Sounds\\Game\\Speech\\Mission\\MS10_SP008B.mp3");
		}
	case 2:
		{
			AddSoundMessage("#iMS10_SP008C#", "Sounds\\Game\\Speech\\Mission\\MS10_SP008C.mp3");
		}
	case 3:
		{
			RemoveEvent( "ArtilleryAttacks" );			
			SetCutScene(false);
			ResetCameraSpeed();   
			SetCameraTargetPos( CamPos );
			SetCameraTargetDistance( CamZoom );
			SetCameraTargetPitch( CamPitch );
			SetCameraTargetRotate( CamRot );
			SetGameSpeed( 1.0 );
			SetObjectiveState( "MarkArea", OS_IN_PROGRESS );
			ActivateEntity( GetEntity("ifrit") );			
			ShowEntity( GetEntity("ifrit") );
			CmdSetMS(  GetEntity("ifrit") , Q_OVERRIDE, MS_CRAWL );
			SetPropertyInt( GetEntity( FowBacaName ), "Team", 0 );
			gSmokeStarted=true;
		}
	}
	ArtiPT++;
}

public MegalljBitang()
{
	RemoveEvent( "MegalljBitang" );
	CmdGroupStop( "starters", Q_OVERRIDE );
	AddSoundMessage("#iMS10_SP001#", "Sounds\\Game\\Speech\\Mission\\MS10_SP001.mp3" );
}

public IntroOver()
{
	static IntroPt=0;
	switch(IntroPt)
	{
	case 0:
			{
				DamageEntity( GetEntity( "hullajelolt" ), 666.666, 49 );
				FormationMoveToEnt("starters",GetEntity( "wp_startpos" ),Q_OVERRIDE, MF_DIRECT);
				new Iterator:iti=Iterate("starters");
				while(ItNext(iti))
				{
					MakeVulnerable(ItEntity(iti));
				}
				RemoveEvent( "IntroOver" );
				AddSoundMessage("#iMS10_SP004A#", "Sounds\\Game\\Speech\\Mission\\MS10_SP004A.mp3");
				AddAKEntityEvent( "IntroOver", ANY_ENTITY, MESSAGE_END );				
			}
	case 1:
			{
				AddSoundMessage("#iMS10_SP004B#", "Sounds\\Game\\Speech\\Mission\\MS10_SP004B.mp3");
			}
	case 2:
			{	
				RemoveEvent( "IntroOver" );
				SetCutScene(false);
				AddMapTickToEnt( GetEntity( "hq_radar" ), 60.0, MAPTICK_CROSS );
				ResetCameraSpeed();    
				SetSpeedInSelector( "starters", 0.0 );
				AddTimerEvent( "MoveHalottz", 6.66, "GameLogic",true );
			}
	}
	IntroPt++;
}
//INTRO--END

public ShowTheRadio()
{
	static RadioPT=0;
	static FowBacaName[100];
	static Float:CamPos[vec3];
	static Float:CamRot;
	static Float:CamZoom;
	static Float:CamPitch;
	switch(RadioPT)
	{
	case 0:
		{
			RemoveEvent( "SendGermanRaider");
			SetGameSpeed( 0.25 );
			GetCameraActualPos( CamPos );
			CamRot=GetCameraActualRotate();
			CamZoom=GetCameraActualDistance();
			CamPitch=GetCameraActualPitch();
			AddSoundMessage("#iMS10_SP005A#", "Sounds\\Game\\Speech\\Mission\\MS10_SP005A.mp3");
			new Float:lTmpVec3[vec3];
			GetPropertyVec3( GetEntity( "hq_radio" ), "LogicalPos_", lTmpVec3 );
			new DrID:FowBaca=CreateEntity( "fowbacon_40", lTmpVec3 );
			SetPropertyInt( FowBaca, "Team", gPlayerTeam );
			GetPropertyString( FowBaca, "StringID", 100, FowBacaName );
			AddAKEntityEvent( "ShowTheRadio", ANY_ENTITY, MESSAGE_END );
			if(GetPropertyInt( GetEntity( "hq_radio" ), "Team" )==gPlayerTeam)
			{
				RadioPT+=10;
			}
			if(GetDifficulty()==0)//Easy
			{
				Reinforcement( "easy_extra", GetEntity( "player_reinf_deploy" ), GetEntity( "wp_startpos" ));
			}
		}
//ha meg nem a mienk a radio.
	case 1:
		{
			AddSoundMessage("#iMS10_SP005B#", "Sounds\\Game\\Speech\\Mission\\MS10_SP005B.mp3");
			MoveCameraToEnt( GetEntity( "hq_radio" ) );
			SetCameraRotSpeed(1.0);
			SetCameraTargetRotate( CamRot+100.0 );
			SetCameraZoomSpeed(1.0);
			SetCameraTargetDistance( 15.0 );
			SetCameraPitchSpeed(5.0);
			SetCameraTargetPitch( 45.0 );
		}
	case 2:
		{
			AddSoundMessage("#iMS10_SP005C#", "Sounds\\Game\\Speech\\Mission\\MS10_SP005C.mp3");
		}
	case 3:
		{
			SetPropertyInt( GetEntity( FowBacaName), "Team", 0 );
			RemoveEvent( "ShowTheRadio" );			
			SetCountDown( Rnd(175,380) );
			AddAKEntityEvent( "StartTheOffensive", ANY_ENTITY, COUNTDOWN_DONE );
			SetCutScene(false);
			ResetCameraSpeed();   
			SetCameraTargetPos( CamPos );
			SetCameraTargetDistance( CamZoom );
			SetCameraTargetPitch( CamPitch );
			SetCameraTargetRotate( CamRot );
			SetObjectiveState( "GetRadio", OS_IN_PROGRESS );
		}
//ha mar a mienk a radio
	case 11:
		{
			MoveCameraToEnt( GetEntity( "hq_radio" ) );
			SetCameraRotSpeed(1.0);
			SetCameraTargetRotate( CamRot+100.0 );
			SetCameraZoomSpeed(1.0);
			SetCameraTargetDistance( 15.0 );
			SetCameraPitchSpeed(5.0);
			SetCameraTargetPitch( 45.0 );
			SetObjectiveState( "GetRadio", OS_IN_PROGRESS );
			AddSoundMessage("#iMS10_SP007B#", "Sounds\\Game\\Speech\\Mission\\MS10_SP007B.mp3");
			SetObjectiveState( "GetRadio", OS_COMPLETED );
			TimeToCallReinf();
		}
	case 12:
		{
			RemoveEvent( "ShowTheRadio" );			
			SetCountDown( Rnd(245,380) );
			AddAKEntityEvent( "StartTheOffensive", ANY_ENTITY, COUNTDOWN_DONE );
			SetCutScene(false);
			ResetCameraSpeed();   
			SetCameraTargetPos( CamPos );
			SetCameraTargetDistance( CamZoom );
			SetCameraTargetPitch( CamPitch );
			SetCameraTargetRotate( CamRot );
		}
	}
	RadioPT++;
}

public ShowTheBombard()
{
	static BombPT=0;
	static FowBacaName[100];
	static Float:CamPos[vec3];
	static Float:CamRot;
	static Float:CamZoom;
	static Float:CamPitch;
	switch(BombPT)
	{
	case 0:
		{
			SetCutScene(true,false,false);
			new DrID:Bombazo=GetEntity( "szonyegezo" );
			ActivateEntity( Bombazo );
			ShowEntity( Bombazo );
			MakeInvulnerable( Bombazo );
//			CmdMoveToEnt( Bombazo, GetEntity( "szonyeg1" ), Q_OVERRIDE, MF_DIRECT );
			new Float:lTmpVec3[vec3];
			GetPropertyVec3( GetEntity( "szonyeg2" ),  "LogicalPos_", lTmpVec3 );
			CmdAttackPos( Bombazo, Q_ENQUEUE, lTmpVec3, AF_FORCE );
			CmdMoveToEnt( Bombazo, GetEntity( "szonyeg3" ), Q_ENQUEUE, MF_DIRECT );
			GetPropertyVec3( GetEntity( "farakas" ), "LogicalPos_", lTmpVec3 );			
//			CreateEntity( "particle_smoke", lTmpVec3 );
			CreateEntity( "particle_fire_big", lTmpVec3, 0.0 );
			CmdGroupMoveToEnt( "megnezok", GetEntity( "megnezni" ), Q_OVERRIDE, MF_ATTACKMOVE );
			GetCameraActualPos( CamPos );
			CamRot=GetCameraActualRotate();
			CamZoom=GetCameraActualDistance();
			CamPitch=GetCameraActualPitch();
			GetPropertyVec3( GetEntity( "wp_bombtarget" ), "LogicalPos_", lTmpVec3 );
			new DrID:FowBaca=CreateEntity( "fowbacon_40", lTmpVec3 );
			SetPropertyInt( FowBaca, "Team", gPlayerTeam );
			GetPropertyString( FowBaca, "StringID", 100, FowBacaName );
			AddSoundMessage("#iMS10_SP009A#", "Sounds\\Game\\Speech\\Mission\\MS10_SP009A.mp3");
			AddAKEntityEvent( "ShowTheBombard", Bombazo, UNIT_BEGIN_COMBAT );
		}
	case 1:
		{
			RemoveEvent( "ShowTheBombard" );
			MoveCameraToEnt( GetEntity( FowBacaName ));
			CameraSet(-100.0, 45.0, 65.0, true)
			AddSoundMessage("#iMS10_SP009B#", "Sounds\\Game\\Speech\\Mission\\MS10_SP009B.mp3");
			AddAKEntityEvent( "ShowTheBombard", GetEntity( "arti2" ), UNIT_DAMAGED );
		}
	case 2:
		{
			RemoveEvent( "ShowTheBombard" );
			SetGameSpeed( 0.15 );
			AddTimerEvent( "ShowTheBombard", 0.5, "GameLogic", true );
		}
	case 3:
		{
			RemoveEvent( "ShowTheBombard" );
			SetGameSpeed( 1.0 );
			AddTimerEvent( "ShowTheBombard", 6.5, "GameLogic", true );
		}
	case 4:
		{
			RemoveEvent( "ShowTheBombard" );
			CmdMoveToEnt( GetEntity( "szonyegezo" ), GetEntity( "szonyeg3" ), Q_OVERRIDE, MF_TELEPORT );
			CmdMoveToEnt( GetEntity( "szonyegezo" ), GetEntity( "szonyeg3" ), Q_CYCLE, MF_NONE );
			AddTimerEvent( "ShowTheBombard", 1.5,"GameLogic",true );				
		}
	case 5:
		{
			CmdStop( GetEntity( "szonyegezo" ),Q_OVERRIDE );
			DeActivateEntity( GetEntity( "szonyegezo" ));
			SetPropertyInt( GetEntity( "fowbacon_201" ), "Team", 0 );
			SetPropertyInt( GetEntity( "fowbacon_202" ), "Team", 0 );
			SetPropertyInt( GetEntity( "fowbacon_203" ), "Team", 0 );
			SetPropertyInt( GetEntity( "fowbacon_204" ), "Team", 0 );
			SetPropertyInt( GetEntity( "fowbacon_205" ), "Team", 0 );
			if(IsAlive(GetEntity( "arti1" )))
			{
				DamageEntity( GetEntity( "arti1" ), 290.1, 49 );
			}
			if(IsAlive(GetEntity( "arti2" )))
			{
				DamageEntity( GetEntity( "arti2" ), 290.1, 49 );
			}
			if(IsAlive(GetEntity( "arti3" )))
			{
				DamageEntity( GetEntity( "arti3" ), 290.1, 49 );
			}
			if(IsAlive(GetEntity( "arti4" )))
			{
				DamageEntity( GetEntity( "arti4" ), 290.1, 49 );
			}
			if(IsAlive(GetEntity( "arti5" )))
			{
				DamageEntity( GetEntity( "arti5" ), 290.1, 49 );
			}
			RemoveEvent( "ShowTheBombard" );			
			SetGameSpeed( 1.0 );
			ResetCameraSpeed();   
			SetCameraTargetPos( CamPos );
			SetCameraTargetDistance( CamZoom );
			SetCameraTargetPitch( CamPitch );
			SetCameraTargetRotate( CamRot );
			SetObjectiveState( "MarkArea", OS_COMPLETED );
			SetPropertyInt( GetEntity( FowBacaName ) , "Team", 0 );
			SetCutScene(false,false,false);
		}
	}
	BombPT++;
}

public TimeToCallReinf()
{
	RemoveEvent( "TimeToCallReinf" );
	new Float:TimeTillReinf=190.0;
	if(MS9HidDone)
	{
		TimeTillReinf-=120.0;	
	}
	AddTimerEvent( "LetsCallReinf", TimeTillReinf, "GameLogic",true );
}

public LetsCallReinf()
{
	if(MS9HidDone)
	{
			AddSoundMessage("#iMS10_SP011#", "Sounds\\Game\\Speech\\Mission\\MS10_SP011.mp3");
	}
	RemoveEvent( "LetsCallReinf" );
	Reinforcement( "player_reinf", GetEntity( "player_reinf_deploy" ), GetEntity( "wp_startpos" ));
}

public MoveHalottz()
{
	RemoveEvent( "MoveHalottz" );
	CmdGroupMoveToEnt( "hullajeloltz" , GetEntity( "wp_startpos" ), Q_OVERRIDE, MF_ATTACKMOVE );
}

public StartTheOffensive()
{
	Reinforcement( "ger_offensive", GetEntity( "ger_off_deploy" ), GetEntity( "geroff1" ));	
	AddTimerEvent( "IgyTalanMukodik1", 2.0, "GameLogic", true );	
	AddSoundMessage("#iMS10_SP006#", "Sounds\\Game\\Speech\\Mission\\MS10_SP006.mp3");
	AddAKEntityEvent( "RemoveTimer", ANY_ENTITY, MESSAGE_END );
}

public SendGermanRaider()
{
	new Tibor=Rnd(0,4);
	new ReinfName[24];
	switch(Tibor)
	{
		case 2:
			{
				ReinfName="ger_raid2";
			}
		case 3:
			{
				ReinfName="ger_raid3";
			}
		default:
			{
				ReinfName="ger_raid1";
			}
	}
	Reinforcement( ReinfName, GetEntity( "ger_off_deploy" ), GetEntity( "geroff1" ));	
	AddTimerEvent( "IgyTalanMukodik2", 2.0, "GameLogic", true );
//	ShowShortMessage( "German Reinforcement has arrived." );
}

public IgyTalanMukodik1()
{
	RemoveEvent( "IgyTalanMukodik1" );
	CmdGroupMoveToEnt( "ger_offensive", GetEntity( "geroff1" ), Q_OVERRIDE, MF_PINPOINT+MF_KEEP_FORMATION+MF_ATTACKMOVE );
	CmdGroupMoveToEnt( "ger_offensive", GetEntity( "geroff2" ), Q_ENQUEUE, MF_KEEP_FORMATION+MF_ATTACKMOVE );
	CmdGroupMoveToEnt( "ger_offensive", GetEntity( "geroff3" ), Q_ENQUEUE, MF_KEEP_FORMATION+MF_ATTACKMOVE );
	CmdGroupMoveToEnt( "ger_offensive", GetEntity( "geroff4" ), Q_ENQUEUE, MF_KEEP_FORMATION+MF_ATTACKMOVE );
	CmdGroupMoveToEnt( "ger_offensive", GetEntity( "geroff5" ), Q_ENQUEUE, MF_KEEP_FORMATION+MF_ATTACKMOVE );
}

public IgyTalanMukodik2()
{
	RemoveEvent( "IgyTalanMukodik2" );
	CmdGroupMoveToEnt( "ger_raid", GetEntity( "geroff1" ), Q_OVERRIDE, MF_PINPOINT+MF_KEEP_FORMATION+MF_ATTACKMOVE );
	CmdGroupMoveToEnt( "ger_raid", GetEntity( "geroff2" ), Q_ENQUEUE, MF_KEEP_FORMATION+MF_ATTACKMOVE );
	CmdGroupMoveToEnt( "ger_raid", GetEntity( "geroff3" ), Q_ENQUEUE, MF_KEEP_FORMATION+MF_ATTACKMOVE );
	CmdGroupMoveToEnt( "ger_raid", GetEntity( "geroff4" ), Q_ENQUEUE, MF_KEEP_FORMATION+MF_ATTACKMOVE );
	CmdGroupMoveToEnt( "ger_raid", GetEntity( "geroff5" ), Q_ENQUEUE, MF_KEEP_FORMATION+MF_ATTACKMOVE );
	new Iterator:iti=Iterate("ger_raid");
	while(ItNext(iti))
	{
		RemoveFromGroup( "ger_raid", ItEntity(iti) );		
	}
	ItStop(iti);
}

public ShowElIfrit()
{
	static IfritPT=0;
	static Float:CamPos[vec3];
	static Float:CamRot;
	static Float:CamZoom;
	static Float:CamPitch;
	static Brit1Name[100];
	static Brit2Name[100];
	new DrID:Brit1=GetEntity( Brit1Name );
	new DrID:Brit2=GetEntity( Brit2Name );
	
	switch(IfritPT)
	{
	case 0:
		{
			SetCutScene(true);
			ActivateEntity( GetEntity( "ifrit" ) );
			ShowEntity( GetEntity( "ifrit" ) );
			GetCameraActualPos( CamPos );
			CamRot=GetCameraActualRotate();
			CamZoom=GetCameraActualDistance();
			CamPitch=GetCameraActualPitch();
			
			new Iterator:iti=Iterate("ifrit_trigger_b");
			if(ItNext(iti))
				Brit1=ItEntity(iti);
						
			if(ItNext(iti))
				Brit2=ItEntity(iti);
			
			ItStop(iti);
			
			GetPropertyString( Brit1, "StringID", 100, Brit1Name );
			GetPropertyString( Brit2, "StringID", 100, Brit2Name );
						
			AddSoundMessage("#iMS10_SP010A#", "Sounds\\Game\\Speech\\Mission\\MS10_SP010A.mp3");
			CmdMoveToEnt( Brit1 , GetEntity( "ifrit_trigger_s" ), Q_OVERRIDE, MF_NONE );
			CmdMoveToEnt( Brit2 , GetEntity( "ifrit_trigger_b" ), Q_OVERRIDE, MF_NONE );
			AddAKEntityEvent( "ShowElIfrit", Brit1, UNIT_COMMAND_QUEUE_EMPTY );
			AddAKEntityEvent( "ShowElIfrit", Brit2, UNIT_COMMAND_QUEUE_EMPTY );
		}
	case 1:
		{
			MoveCameraToEnt( GetEntity( "ifrit" ));
		}
	case 2:
		{
			RemoveEvent( "ShowElIfrit" );
			AddSoundMessage("#iMS10_SP010B#", "Sounds\\Game\\Speech\\Mission\\MS10_SP010B.mp3");
			AddAKEntityEvent( "ShowElIfrit", ANY_ENTITY, MESSAGE_END );
		}
	case 3:
		{
			DamageEntity( GetEntity( "ifrit" ), 100.0,49 );
			MoveCameraToEnt( Brit1);
			AddSoundMessage("#iMS10_SP010C#", "Sounds\\Game\\Speech\\Mission\\MS10_SP010C.mp3");
		}
	case 4:
		{
			MoveCameraToEnt( Brit2);
			AddSoundMessage("#iMS10_SP010D#", "Sounds\\Game\\Speech\\Mission\\MS10_SP010D.mp3");		
		}
	case 5:
		{
			MoveCameraToEnt( Brit1);
			AddSoundMessage("#iMS10_SP010E#", "Sounds\\Game\\Speech\\Mission\\MS10_SP010E.mp3");		
		}
	case 6:
		{		
			SetCutScene(false);
			ResetCameraSpeed();   
			SetCameraTargetPos( CamPos );
			SetCameraTargetDistance( CamZoom );
			SetCameraTargetPitch( CamPitch );
			SetCameraTargetRotate( CamRot );
			SetGameSpeed( 1.0 );
			SetObjectiveState( "FindIfrit", OS_COMPLETED );
		}	
	}
	IfritPT++;
}

public RemoveTimer()
{
	RemoveEvent( "RemoveTimer" );
	SetCountDown( -1 );
}

//======================================================================================================
public TeamElimSucceed( )
{
	new Team=GetMsgParamInt();      
	if(Team==123)
	{
		GameOverMan();
		SetObjectiveState( "GetRadar", OS_FAILED );		
		SetObjectiveState( "HoldNarrow", OS_FAILED );		
	}
	if(Team==666&&GetDifficulty()==0)
	{
		Reinforcement( "easy_extra", GetEntity( "player_reinf_deploy" ), GetEntity( "wp_startpos" ));
	}
}

public GameOverMan()
{
	RemoveEvent( "GameOverMan" );
	SetCutScene(true);
	AddDebriefing("#iMISSION_DB_F#");
	EndMission( MS_FAILED );
}

public GameDoneMan()
{
	SetObjectiveState( "HoldNarrow", OS_COMPLETED );
	if(	GetObjectiveState( "FindIfrit") != OS_COMPLETED )
	{
		SetGlobalVariable("gvMS10_Elifrit",0)		
		SetObjectiveState( "FindIfrit", OS_FAILED );
	}
	else
	{
		SetGlobalVariable("gvMS10_Elifrit",1)		
	}
	RemoveEvent( "GameDoneMan" );
	SetCutScene(true);
	AddDebriefing("#iMISSION10_DB_P#");
	if(GetObjectiveState( "FindIfrit" )==OS_COMPLETED)
	{
		AddDebriefing("#iMISSION10_DB_H#");
	}
	EndMission( MS_ACCOMPLISHED );
}

public SendRadioSoldiers()
{
	RemoveEvent( "SendRadioSoldiers" );
//	ShowShortMessage( "Radio tower is reinforced" );
	Reinforcement( "radio_reinf", GetEntity( "radio_reinf_deploy" ), GetEntity( "radio_reinf_arrive" ) );
	CmdGroupMoveToEnt( "radio_reinf", GetEntity( "radio_reinf_arrive" ), Q_OVERRIDE, MF_NONE );
	new Iterator:iti=Iterate("radio_reinf");
	while(ItNext(iti))
	{
		if(IsMounted( ItEntity(iti)))
		{ //Gyalog
			SetBehav2Ent( ItEntity(iti),MB_MOVE_FREELY,FB_FIRE_AT_WILL,UB_NEVER);
		}
		else
		{ //kocsi
			SetBehav2Ent( ItEntity(iti),_,FB_FIRE_AT_WILL,UB_NEVER);
			CmdUnmount( ItEntity(iti), Q_ENQUEUE, UMTF_UNMOUNT_ALL );
			AddAKEntityEvent( "RadioReinfDmgd", ItEntity(iti), UNIT_DAMAGED );
		}
		ItStop(iti);
	}
}

public RadioReinfDmgd(DrID:Hu)
{
	RemoveEvent( "RadioReinfDmgd" );
	CmdUnmount( Hu, Q_OVERRIDE );
	AddTimerEvent( "RRDMGD2", 1.0, "GameLogic", true);
}

public RRDMGD2()
{
	RemoveEvent( "RRDMGD2" );
	CmdGroupMoveToEnt( "radio_reinf", GetEntity( "radio_reinf_arrive" ), Q_OVERRIDE, MF_ATTACKMOVE );
}
//======================================================================================================
// Add your functions here:

//======================================================================================================
public ObjectiveChanged()
{
	// Check objectives here
}
